' module: conjugation

declare sub chooseConj(exercise as TExercise, opt as integer = SETTING_OPTIONS.NONE)
scope
  dim as TList conjList
  with conjList
    .listName = "conjugation"
    .add , 0, &hffffff, "group", "verb"
    .load
    .save
    .list.clear
  end with
end scope
' TEMPORARY DEACTIVATED
'globalExercises.add(TExercise("Konjugationen", "conjugation", 0, @pairs, @infoEmpty, @chooseConj))

sub chooseConj(exercise as TExercise, opt as integer = SETTING_OPTIONS.NONE)
  dim as integer lXstart =  20, lYstart =  90, lWidth =  60, lHeight = 20
  dim as integer lXplus  =  10, lYplus  =   5, lMod   =  11, lLines  = 10
  dim as integer cXstart =  20, cYstart = 390, cWidth = 240, cHeight = 28
  dim as integer cXplus  =  10, cYplus  =   5, cMod   =   3, cLines  =  3
  dim as integer mXstart = 140, mYStart =  30, mWidth =  40, mHeight = 20
  dim as integer mXPlus  =  20, mYPlus  =   0, mMod   =   8, mLines  =  1
  dim as string conjString(...) = { "presente de indicativo" }
' pretérito imperfecto, pretérito perfecto, pretérito pluscuamperfecto
' pretérito anterior, futuro simple, futuro compuesto
' jeweils indicativo und subjunctivo; zusätzlich
' pretérito indefinido (indefinido) und imperativo

  dim as integer mx, my, mb
  dim as long lession, lessions(lMod*lLines-1), lCount = 0
  dim as short cChoose
  dim as byte lByte(lMod*lLines-1)
  dim as string key, tagname
  dim as mdList(long) ks1 = listOfLessions.keySet
  dim as FB.Image ptr lImg, cImg, mImg
  if len(exercise.settingString) < lMod*lLines + 3 then
    exercise.settingString &= string((lMod*lLines + 3) - len(exercise.settingString), 0)
  end if
  cChoose = (exercise.settingString[1] shl 8) and exercise.settingString[2]
  if opt <> 0 then
    lImg = imagecreate(lWidth-3, lHeight-3, &hffffff)
    cImg = imagecreate(cWidth-3, cHeight-3, &hffffff)
    mImg = imagecreate(mWidth-3, mHeight-3, &hffffff)
    cls
    printFT 20, 60, "Wörter aus folgenden Kapiteln:", font, 16
  end if

  ' draw
  foreach(long, lession, ks1)
    if lession >= 100 then
      if opt <> 0 then
        line (lXstart+(lCount mod lMod)*(lWidth+lXplus),   lYStart+(lCount\lMod)*(lHeight+lYplus)) _
             -step(lWidth, lHeight), 0, bf
        line (lXstart+(lCount mod lMod)*(lWidth+lXplus)+2, lYStart+(lCount\lMod)*(lHeight+lYplus)+2) _
             -step(lWidth-4, lHeight-4), &hffffffff, bf
        centerFT lXstart+lWidth\2+(lCount mod lMod)*(lWidth+lXplus), _
                 lYstart+lHeight\2+(lCount\lMod)*(lHeight+lYplus)+2, _
                 format(lession/100, "###.00"), font, 14
      end if
      lessions(lCount) = lession
      lCount += 1
      if lCount = lMod*lLines then exit while
    end if
  nexteach
  if opt <> 0 then
    printFT 20, 350, "Konjugationsformen:", font, 16
    'drawButtons cXstart, cYstart, cWidth, cHeight, cXplus, cYplus, cMod, cLines, conjString()
  end if
  if opt <> 0 then
    printFT 20, mYStart, "Markierung:", font, 16
    for i as integer = 0 to 7
      line (mXstart+i*(mWidth+mXplus), mYStart)-step(mWidth, mHeight), 0, bf
      line (mXstart+i*(mWidth+mXplus)+2, mYStart+2)-step(mWidth-4, mHeight-4), &hffffffff, bf
      centerFT mXstart+mWidth\2+i*(mWidth+mXplus), mYstart+mHeight\2+2, str(i+1), font, 14
    next
  end if

  ' mark selected items
  for i as integer = 0 to lMod*lLines-1
    if exercise.settingString[i+3] > 0 then
      lByte(i) = 1
      if opt <> 0 then
        put (lXstart+(i mod lMod)*(lWidth+lXplus)+2, lYStart+(i\lMod)*(lHeight+lYplus)+2), lImg, xor
      end if
    end if
  next
  for i as integer = 0 to ubound(conjString)
    if bit(cChoose, i) then
      if opt <> 0 then
        put (cXstart+i*(cWidth+cXplus)+2, cYStart+2), cImg, xor
      end if
    end if
  next
  for i as integer = 0 to 8
    if bit(exercise.settingString[0], i) then
      if opt <> 0 then
        put (mXstart+i*(mWidth+mXplus)+2, mYStart+2), mImg, xor
      end if
    end if
  next

  ' check input
  if opt <> 0 then
    do
      key = inkey
      for i as integer = 0 to 7
        if checkMouseIn(mXstart+i*(mWidth+mXplus), mYStart, mWidth, mHeight, 1) then
          if bit(exercise.settingString[0], i) then
            exercise.settingString[0] = bitreset(exercise.settingString[0], i)
          else
            exercise.settingString[0] = bitset(exercise.settingString[0], i)
          end if
          put (mXstart+i*(mWidth+mXplus)+2, mYStart+2), mImg, xor
          do
            getmouse mx, my,, mb
            sleep 1
          loop until mb = 0
        end if
      next
      for i as integer = 0 to lCount-1
        if checkMouseIn(lXstart+(i mod lMod)*(lWidth+lXplus), lYStart+(i\lMod)*(lHeight+lYplus), _
                        lWidth, lHeight, 1) then
          lByte(i) = 1-lByte(i)
          exercise.settingString[i+1] = lByte(i)
          put (lXstart+(i mod lMod)*(lWidth+lXplus)+2, lYStart+(i\lMod)*(lHeight+lYplus)+2), lImg, xor
          do
            getmouse mx, my,, mb
            sleep 1
          loop until mb = 0
        end if
      next
      for i as integer = 0 to ubound(conjString)
        if checkMouseIn(cXstart+(i mod cMod)*(cWidth+cXplus), cYStart+(i\cMod)*(cHeight+cYplus), _
                        cWidth, cHeight, 1) then
          if bit(cChoose, i) then
            cChoose = bitreset(cChoose, i)
          else
            cChoose = bitset(cChoose, i)
          end if
          exercise.settingString[1] = cChoose shr 8
          exercise.settingString[1] = cChoose and 255
          put (cXstart+(i mod cMod)*(cWidth+cXplus)+2, cYStart+(i\cMod)*(cHeight+cYplus)+2), cImg, xor
          do
            getmouse mx, my,, mb
            sleep 1
          loop until mb = 0
        end if
      next
      sleep 1
    loop until key = chr(27) or key = chr(255, 107)
  end if

  ' create exercise.currentList
  exercise.currentList.list.clear
  dim tempList as TList, tempLP as TListPoint
  for i as integer = 0 to lCount-1
    if lByte(i) then tempList.add , lessions(i), lessions(i)
  next
  for i as integer = 0 to 7
    if bit(exercise.settingString[0], i) then tempList.add , 0, &hffffff, "mark", str(i+1)
  next
  foreach(TListPoint, tempLP, tempList.list)
    for i as integer = 0 to ubound(conjString)
      if bit(exercise.settingString[0], i) then
        for k as integer = 0 to 5
          tempLP.special = i*6+k
          exercise.currentList.list.add(tempLP)
        next
      end if
    next
  nexteach
  exercise.currentList.list.addAll(tempList.list)
  exercise.updateLists
  if opt <> 0 then
    imagedestroy lImg
    imagedestroy cImg
    imagedestroy mImg
  end if
end sub

